package csci1902.hw3;

import java.awt.Point;

/**
 * Base class for ants.  Implements common ant behavior.
 * @author Michael Ekstrand <ekstrand@cs.umn.edu>
 *
 */
public class Ant extends Entity {

    private Point homePosition;
    private World world;
    public Ant(World w, Point initPos) {
        super(w, initPos);
        homePosition = initPos;
        world=w;
    }

    /**
     * Retrieve the ant's home position
     * @return The ant's home position
     */
    public Point getHomePosition() {
        return homePosition;
    }
    
    /**
     * Make the ant walk towards its home.
     */
    protected void goTowardsHome() {
        Point pos = getPosition();
        Point nextPos;
        double dx, dy;
        dx = homePosition.x - pos.x;
        dy = homePosition.y - pos.y;
        double distance = Math.sqrt(dx * dx + dy * dy);
        dx /= distance;
        dy /= distance;
        nextPos = new Point(
                pos.x + (int) Math.round(dx),
                pos.y + (int) Math.round(dy));
        if (nextPos.equals(pos) && !nextPos.equals(homePosition)) {
           if (nextPos.x != homePosition.x) {
               // try moving X
               if (nextPos.x > homePosition.x)
                   nextPos.x--;
               else
                   nextPos.x++;
           } else {
               // X is home, try moving Y
               if (nextPos.y > homePosition.y)
                   nextPos.y--;
               else
                   nextPos.y++;
           }
        }
        setNextPosition(nextPos);
    }
    public boolean isEdible(){
		return true;
	}
	public boolean eat(){
		boolean eaten=false;
		eaten = world.getRandomGenerator().getBoolean(.5);
		if (eaten == true){
			die();
		}
		return eaten;
	}
}