package csci1902.hw3;

import junit.framework.TestCase;

public abstract class AntTestBase extends TestCase {

    protected World world;
    protected FakeRandomGenerator rng;

    /**
     * Construct a new forager ant to test its behavior.
     */
    protected void setUp() {
        rng = new FakeRandomGenerator();
        world = new World(10, 10);
        world.setRandomGenerator(rng);
    }
    
    protected abstract Ant getAnt();
    
    /**
     * Test that the ant behaves properly when eaten.
     */
    public void testEdible() {
        Ant ant = getAnt();
        assertTrue(ant.isEdible());
        rng.addNumber(0.7);
        assertFalse(ant.eat());
        assertFalse(ant.isDying());
        ant.update();
        assertTrue(ant.isAlive());
        assertFalse(ant.isDying());
        
        rng.addNumber(0.3);
        assertTrue(ant.eat());
        assertTrue(ant.isDying());
        assertTrue(ant.isAlive());
        ant.update();
        assertFalse(ant.isAlive());
    }
}
