package csci1902.hw3;

import java.awt.Point;

/**
 * Implementation of the ant colony.
 * @author Michael Ekstrand <ekstrand@cs.umn.edu>
 *
 */
public class Colony extends Entity {
    private int foodLevel = 0;
    private int wasteLevel = 0;
    
    private int nextFood = 0;
    private int nextWaste = 0;
    
    public Colony(World w, Point p) {
        super(w, p);
    }
    
    /**
     * Query the food level of the colony.
     * @return the colony's food level.
     */
    public int getFoodLevel() {
        return foodLevel;
    }
    /**
     * Query the waste level of the colony.
     * @return the colony's waste level.
     */
    public int getWasteLevel() {
        return wasteLevel;
    }
    
    public boolean isFoodSink() {
        return true;
    }
    public void depositFood(int amount) {
        nextFood += amount;
    }
    
    public boolean isWasteSource() {
        return true;
    }
    
    public int collectWaste(int amount) {
        return amount;  // the colony has infinite waste
    }
    
    public void update() {
        super.update();
        foodLevel = nextFood;
        wasteLevel = nextWaste;
    }
}
