package csci1902.hw3;

import java.util.*;

/**
 * Fake random number generator for testing purposes.
 * @author Michael Ekstrand <ekstrand@cs.umn.edu>
 *
 */
public class FakeRandomGenerator extends RandomGenerator {
    double dflt = 0;
    Queue<Double> sequence = new LinkedList<Double>();
    
    /**
     * Set the default value to be returned by this generator when no numbers
     * are in the queue.
     * @param d The default number.
     */
    public void setDefault(double d) {
        dflt = d;
    }
    
    /**
     * Add a number to the back of the LIFO queue of numbers to return.
     * @param num The number to add to the queue.
     */
    public void addNumber(double num) {
        sequence.add(num);
    }
    
    /**
     * Get the next number.  If there are numbers in the sequence, the next one
     * is removed and returned; otherwise, the default value is returned.
     */
    public double getNumber() {
        if (sequence.isEmpty()) {
            return dflt;
        } else {
            return sequence.remove();
        }
    }

}
