package csci1902.hw3;

/**
 * Interface for random number generators.
 * @author Michael Ekstrand <ekstrand@cs.umn.edu>
 *
 */
public abstract class RandomGenerator {
    /**
     * Return the next number in the random sequence.  When backed by a real
     * random number generator, this is uniformly distributed.
     * @return A uniformly distributed pseudorandom number in the range [0.0,1.0].
     */
    public abstract double getNumber();
    
    /**
     * Get a boolean value
     * @param probability The probability (> 0, < 1) of a true value.
     * @return true if getNumber() is less than the probability.
     */
    public boolean getBoolean(double probability) {
        return getNumber() < probability;
    }
}
