package csci1902.hw3;

import java.awt.Point;

/**
 * Class implementing a waste dump site.
 * @author Michael Ekstrand <ekstrand@cs.umn.edu>
 *
 */
public class WasteDump extends Entity {
    private int wasteUnits, nextWaste;
    
    public WasteDump(World w, Point p) {
        super(w, p);
        wasteUnits = 0;
        nextWaste = 0;
    }
    
    /**
     * Retrieve the amount of waste at this dump.
     * @return
     */
    public int getWasteUnits() {
        return wasteUnits;
    }
    
    public boolean isWasteSink() {
        return true;
    }
    
    public void depositWaste(int amount) {
        nextWaste += amount;
    }
    
    public void update() {
        super.update();
        wasteUnits = nextWaste;
    }
}
